/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.pvp.EPvPStage
 *  fire.pb.battle.pvp.IPvPStage
 *  fire.pb.battle.pvp.PvPControl
 *  fire.pb.buff.Module
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.MapConfig
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.map.Transfer
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.TeamManager
 *  fire.pb.util.StringConstant
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xtable.Properties
 */
package fire.pb.battle.pvp3;

import fire.pb.battle.pvp.EPvPStage;
import fire.pb.battle.pvp.IPvPStage;
import fire.pb.battle.pvp.PvPControl;
import fire.pb.battle.pvp3.PvP3Helper;
import fire.pb.battle.pvp3.PvP3RaceProxy;
import fire.pb.battle.pvp3.PvP3RoleProxy;
import fire.pb.battle.pvp3.PvP3RoleStateManager;
import fire.pb.battle.pvp3.PvP3Stage;
import fire.pb.battle.pvp3.SPvP3ReadyFight;
import fire.pb.buff.Module;
import fire.pb.main.ConfigManager;
import fire.pb.map.MapConfig;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.map.Transfer;
import fire.pb.talk.MessageMgr;
import fire.pb.team.TeamManager;
import fire.pb.util.StringConstant;
import java.util.List;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xtable.Properties;

public class PvP3Control
extends PvPControl {
    public static PvP3Control getInstance() {
        return SingletonHolder.singleton;
    }

    public static Logger getLogger() {
        return logger;
    }

    public void init(long start, long end, long fightStart, long fightEnd) {
        super.init(start, end, fightStart, fightEnd);
        PvP3RoleStateManager.getInstance().init();
        if (logger.isInfoEnabled()) {
            logger.info((Object)"PVP3::[PvP3Control.init] .");
        }
    }

    public void end() {
        super.end();
        if (logger.isInfoEnabled()) {
            logger.info((Object)"PVP3::[PvP3Control.end] .");
        }
    }

    public void close() {
        for (final int grade : PvP3Helper.getAllRaceIds()) {
            new Procedure(){

                protected boolean process() {
                    PvP3RaceProxy race = PvP3RaceProxy.getPvP3RaceProxy(grade);
                    race.clear();
                    return true;
                }
            }.submit();
        }
    }

    protected void registerStage() {
        this.stageManager.register(EPvPStage.NOTOPEN, (IPvPStage)new PvP3Stage.NotOpen());
        this.stageManager.register(EPvPStage.START, (IPvPStage)new PvP3Stage.Start());
        this.stageManager.register(EPvPStage.PREPARE, (IPvPStage)new PvP3Stage.Prepare());
        this.stageManager.register(EPvPStage.FIGHT, (IPvPStage)new PvP3Stage.Fight());
        this.stageManager.register(EPvPStage.END, (IPvPStage)new PvP3Stage.End());
        this.stageManager.register(EPvPStage.AWARD, (IPvPStage)new PvP3Stage.Award());
    }

    public int getActivityNpcConfigId() {
        return 8;
    }

    public boolean doApplyEnter(long roleId, int gotoType) {
        if (!this.isActivityTime()) {
            MessageMgr.sendMsgNotify((long)roleId, (int)160348, null);
            return false;
        }
        PvP3RoleProxy pvpRoleProxy = PvP3RoleProxy.getPvP3RoleProxy(roleId, true);
        if (pvpRoleProxy == null) {
            return false;
        }
        int grade = pvpRoleProxy.getGradeInActivity();
        if (grade <= 0) {
            grade = PvP3Helper.getRaceGradeByRoleId(roleId);
        }
        if (grade <= 0) {
            List param = MessageMgr.getStringList((Object[])new Object[]{45, StringConstant.ID2String((String)"3v3竞技场", (int)293)});
            MessageMgr.sendMsgNotify((long)roleId, (int)160340, (List)param);
            return false;
        }
        int error = PvP3Helper.checkRoleEnterCondition(roleId, grade);
        if (error != 0) {
            switch (error) {
                case -1: {
                    MessageMgr.sendMsgNotify((long)roleId, (int)141206, null);
                    break;
                }
                case -2: {
                    MessageMgr.sendMsgNotify((long)roleId, (int)160337, null);
                    break;
                }
                default: {
                    MessageMgr.sendMsgNotify((long)roleId, (int)160339, null);
                }
            }
            return false;
        }
        Role mapRole = RoleManager.getInstance().getRoleByID(roleId);
        if (mapRole == null) {
            return false;
        }
        int mapId = PvP3Helper.getMapIdByRaceGrade(grade);
        if (mapId == mapRole.getMapId()) {
            this.onRoleEnterScene(roleId, mapId);
            return true;
        }
        MapConfig mapConf = (MapConfig)ConfigManager.getInstance().getConf(MapConfig.class).get(mapId);
        boolean ret = Transfer.justGotoDeltaWhileCommit((long)roleId, (long)mapId, (int)mapConf.getXjPos(), (int)mapConf.getYjPos(), (int)gotoType, (int)10);
        return ret;
    }

    public void doApplyLeave(long roleId) {
        this.transferOutScene(roleId);
    }

    public boolean onRoleEnterScene(final long roleId, int mapId) {
        final int grade = PvP3Helper.getRaceGradeByMapId(mapId);
        if (grade <= 0) {
            return false;
        }
        if (!this.isActivityTime()) {
            if (!(Module.existState((long)roleId, (int)507004) || Module.existState((long)roleId, (int)507005) || Module.existState((long)roleId, (int)507027))) {
                this.forceLeave(roleId);
            }
            return true;
        }
        if (Transaction.current() != null) {
            TeamManager.getInstance().delTeamMatchAsyn(roleId);
        } else {
            new Procedure(){

                public boolean process() {
                    TeamManager.getInstance().delTeamMatchAsyn(roleId);
                    return true;
                }
            }.submit();
        }
        Procedure proc = new Procedure(){

            protected boolean process() {
                PvP3RaceProxy race = PvP3RaceProxy.getPvP3RaceProxy(grade);
                return race.roleEnter(roleId);
            }
        };
        if (Transaction.current() != null) {
            Procedure.pexecuteWhileCommit((Procedure)proc);
        } else {
            proc.submit();
        }
        return true;
    }

    public boolean onRoleLeaveScene(final long roleId, int mapId, boolean isChangeMap) {
        final int grade = PvP3Helper.getRaceGradeByMapId(mapId);
        if (grade <= 0) {
            return false;
        }
        PvP3RoleStateManager.getInstance().setRolePvPState(roleId, 0);
        Procedure proc = new Procedure(){

            protected boolean process() {
                PvP3RaceProxy race = PvP3RaceProxy.getPvP3RaceProxy(grade);
                return race.roleLeave(roleId);
            }
        };
        if (Transaction.current() != null) {
            Procedure.pexecuteWhileCommit((Procedure)proc);
        } else {
            proc.submit();
        }
        return true;
    }

    public void onRoleOnline(long roleId, int mapId) {
        if (!this.onRoleEnterScene(roleId, mapId)) {
            PvP3Helper.summonByRole(roleId, mapId);
        }
    }

    public void onRoleOffline(long roleId) {
        int mapId = Properties.selectSceneid((Long)roleId).intValue();
        this.onRoleLeaveScene(roleId, mapId, false);
    }

    public boolean doGetAward(final long roleId, final int boxType) {
        new Procedure(){

            protected boolean process() {
                PvP3RoleProxy pvpRoleProxy = PvP3RoleProxy.getPvP3RoleProxy(roleId, false);
                return pvpRoleProxy.openBox(boxType);
            }
        }.submit();
        return true;
    }

    public void onTeamMemberLeave(long roleId) {
        Role mapRole = RoleManager.getInstance().getRoleByID(roleId);
        if (mapRole != null && PvP3Helper.isPvPMap(mapRole.getMapId()) && !PvP3RoleStateManager.getInstance().checkPvPStateCanOperationTeam(roleId)) {
            Procedure.psendWhileCommit((long)roleId, (Protocol)new SPvP3ReadyFight(0));
            PvP3RoleStateManager.getInstance().setRolePvPState(roleId, 0);
        }
    }

    static class SingletonHolder {
        static PvP3Control singleton = new PvP3Control();

        SingletonHolder() {
        }
    }
}

